Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushEntry.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushEntry.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushEntry.cs	(revision 15334)
@@ -9,4 +9,11 @@
     public PlushEntry() { }
 
+    public PlushEntry(Expression instruction = null, int close = 0, bool silent = false) {
+      Instruction = instruction;
+      Close = close;
+      Silent = silent;
+    }
+
+    [StorableConstructor]
     public PlushEntry(bool deserializing) : base(deserializing) { }
 
@@ -14,4 +21,5 @@
       Instruction = cloner.Clone(origin.Instruction);
       Close = origin.Close;
+      Silent = origin.Silent;
     }
 
@@ -20,4 +28,6 @@
     [Storable]
     public int Close { get; set; }
+    [Storable]
+    public bool Silent { get; set; }
 
     public override IDeepCloneable Clone(Cloner cloner) {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushVector.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushVector.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushVector.cs	(revision 15334)
@@ -1,5 +1,4 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Encoding {
   using System.Collections.Generic;
-
   using HeuristicLab.Common;
   using HeuristicLab.Core;
@@ -9,5 +8,5 @@
 
   [StorableClass]
-  public class PlushVector : Item {
+  public sealed class PlushVector : Item {
 
     [Storable]
@@ -22,9 +21,13 @@
 
     [StorableConstructor]
-    public PlushVector(bool deserializing) : base(deserializing) {
+    private PlushVector(bool deserializing) : base(deserializing) {
     }
 
     public PlushVector(PlushVector origin, Cloner cloner) : base(origin, cloner) {
-      entries = new List<PlushEntry>(origin.entries);
+      entries = new List<PlushEntry>(origin.entries.Count);
+      for (var i = 0; i < origin.entries.Count; i++) {
+        entries.Add(cloner.Clone(origin.entries[i]));
+      }
+
       pushProgram = origin.pushProgram;
     }
@@ -62,27 +65,28 @@
       var instructions = new List<Expression>();
 
-      for (var i = currentIndex; i < entries.Count; i++) {
-        var entry = entries[i];
+      for (; currentIndex < entries.Count; currentIndex++) {
+        var entry = entries[currentIndex];
+
+        if (entry.Silent)
+          continue;
+
+        close += entry.Close;
+        instructions.Add(entry.Instruction);
+
+        PushExpressionAttribute attribute;
         var instructionType = entry.Instruction.GetType();
 
-        close += entry.Close;
-
-        PushExpressionAttribute attribute;
         if (ExpressionTable.TypeToAttributeTable.TryGetValue(instructionType, out attribute)) {
-          for (var blockIdx = 0u; blockIdx < attribute.ExecIn && currentIndex < entries.Count; blockIdx++) {
-            if (close != 0) {
+          for (var blockIdx = 0u; blockIdx < attribute.RequiredBlockCount; blockIdx++) {
+            if (close == 0 && currentIndex < entries.Count) {
+              currentIndex++;
+              var subProgram = FromPlush(ref currentIndex, ref close, depth + 1);
+              instructions.Add(subProgram);
+            } else {
               close--;
               instructions.Add(PushProgram.Empty);
-            } else {
-              currentIndex++;
-              var subProgram = FromPlush(ref currentIndex, ref close, depth + 1);
-              var subExpression = subProgram.Count == 1 ? subProgram.Expressions[0] : subProgram;
-
-              instructions.Add(subExpression);
             }
           }
         }
-
-        instructions.Add(entry.Instruction);
 
         if (close > 0 && depth > 0) {
@@ -96,4 +100,5 @@
       }
 
+      instructions.Reverse();
       return new PushProgram(instructions);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Evaluator/PushBenchmarkSuiteEvaluator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Evaluator/PushBenchmarkSuiteEvaluator.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Evaluator/PushBenchmarkSuiteEvaluator.cs	(revision 15334)
@@ -3,4 +3,5 @@
   using System.Collections.Generic;
   using System.Globalization;
+  using System.Linq;
 
   using HeuristicLab.BenchmarkSuite;
@@ -9,4 +10,5 @@
   using HeuristicLab.Parameters;
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Extensions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
@@ -18,14 +20,14 @@
   public class PushBenchmarkSuiteEvaluator : ParameterizedNamedItem, IPushEvaluator {
 
-    private const string DataBoundsParameterName = "DataBounds";
-    private const string DataParameterName = "Data";
-    private const string DataParameterDescription = "Program Synthesis";
+    private const string DATA_BOUNDS_PARAMETER_NAME = "DataBounds";
+    private const string DATA_PARAMETER_NAME = "Data";
+    private const string DATA_PARAMETER_DESCRIPTION = "Program Synthesis";
 
     public PushBenchmarkSuiteEvaluator() {
-      Parameters.Add(new FixedValueParameter<DataBounds>(DataBoundsParameterName));
+      Parameters.Add(new FixedValueParameter<DataBounds>(DATA_BOUNDS_PARAMETER_NAME));
 
       Parameters.Add(new ValueParameter<ProblemData>(
-        DataParameterName,
-        DataParameterDescription));
+        DATA_PARAMETER_NAME,
+        DATA_PARAMETER_DESCRIPTION));
     }
 
@@ -47,5 +49,5 @@
     public IValueParameter<ProblemData> DataParameter
     {
-      get { return (IValueParameter<ProblemData>)Parameters[DataParameterName]; }
+      get { return (IValueParameter<ProblemData>)Parameters[DATA_PARAMETER_NAME]; }
     }
 
@@ -58,5 +60,5 @@
     public IValueParameter<DataBounds> DataBoundsParameter
     {
-      get { return (IValueParameter<DataBounds>)Parameters[DataBoundsParameterName]; }
+      get { return (IValueParameter<DataBounds>)Parameters[DATA_BOUNDS_PARAMETER_NAME]; }
     }
 
@@ -131,6 +133,48 @@
 
       switch (Data.ProblemType) {
+        // special
         case ProblemType.NumberIO: return NumberIo(interpreter, example);
-        case ProblemType.Median: return Median(interpreter, example);
+        case ProblemType.StringDifferences: return StringDifferences(interpreter, example);
+        case ProblemType.EvenSquares: return EvenSquares(interpreter, example);
+        case ProblemType.WallisPi: return WallisPi(interpreter, example);
+        case ProblemType.VectorSummed: return VectorsSummed(interpreter, example);
+        case ProblemType.XWordLines: return XWordLines(interpreter, example);
+        case ProblemType.NegativeToZero: return NegativeToZero(interpreter, example);
+        case ProblemType.WordStats: return WordStats(interpreter, example);
+        case ProblemType.Checksum: return Checksum(interpreter, example);
+        case ProblemType.Grades: return Grade(interpreter, example);
+        case ProblemType.Syllables: return Syllables(interpreter, example);
+
+        // printed string right/wrong
+        case ProblemType.Smallest:
+        case ProblemType.Median: return PrintedStringRight(interpreter, example);
+
+        // boolean error
+        case ProblemType.MirrorImage:
+        case ProblemType.SuperAnagrams:
+        case ProblemType.CompareStringLengths: return GetDiff(example.OutputBoolean, interpreter.BooleanStack, Data.WorstResult, BooleanDiffer);
+
+        // float error
+        case ProblemType.VectorAverage: return GetDiff(example.OutputFloat, interpreter.FloatStack, Data.WorstResult, (a, b) => FloatDiffer(a, b, example.OutputFloatPrecision));
+
+        // integer error
+        case ProblemType.LastIndexOfZero:
+        case ProblemType.CountOdds:
+        case ProblemType.SumOfSquares:
+        case ProblemType.ScrabbleScore:
+        case ProblemType.CollatzNumbers: return GetDiff(example.OutputInteger, interpreter.IntegerStack, Data.WorstResult, IntegerDiffer);
+
+        // levenshtein distance + integer error
+        case ProblemType.ReplaceSpaceWithNewline:
+          return GetPrintDiffer(example.OutputPrint, interpreter.PrintStack, Data.WorstResult)
+               + GetDiff(example.OutputInteger, interpreter.IntegerStack, Data.WorstResult, IntegerDiffer);
+
+        // printed levenshtein distance
+        case ProblemType.ForLoopIndex:
+        case ProblemType.DoubleLetters:
+        case ProblemType.StringLengthsBackwards:
+        case ProblemType.PigLatin:
+        case ProblemType.Digits:
+        case ProblemType.SmallOrLarge: return GetPrintDiffer(example.OutputPrint, interpreter.PrintStack, Data.WorstResult);
       }
 
@@ -163,10 +207,13 @@
     }
 
-    private double Median(IPushInterpreter interpreter, Example example) {
-      return interpreter.PrintStack.IsEmpty || !interpreter.PrintStack.ToString().Equals(example.OutputPrint) ? 1 : 0;
+    private double PrintedStringRight(IPushInterpreter interpreter, Example example) {
+      return interpreter.PrintStack.IsEmpty ||
+             !interpreter.PrintStack.ToString().Equals(example.OutputPrint)
+             ? 1
+             : 0;
     }
 
     private double NumberIo(IPushInterpreter interpreter, Example example) {
-      if (interpreter.PrintStack.IsEmpty)
+      if (!string.IsNullOrEmpty(example.OutputPrint) && interpreter.PrintStack.IsEmpty)
         return Data.WorstResult;
 
@@ -176,7 +223,7 @@
       if (double.TryParse(printResult, NumberStyles.Number | NumberStyles.AllowDecimalPoint, CultureInfo.InvariantCulture, out value)) {
         var diff = Math.Abs(example.OutputFloat[0] - value);
-        var result = Math.Min(diff, Data.WorstResult);
-
-        return result;
+        diff = Math.Min(diff, Data.WorstResult);
+
+        return diff;
       }
 
@@ -187,5 +234,248 @@
         Data.WorstResult);
 
-      return levenshteinDistance + penaltyError;
+      var result = levenshteinDistance + penaltyError;
+      return Math.Min(result, Data.WorstResult);
+    }
+
+    private double StringDifferences(IPushInterpreter interpreter, Example example) {
+      if (string.IsNullOrEmpty(example.OutputPrint) && interpreter.PrintStack.IsEmpty) {
+        return 0.0;
+      }
+
+      if (!string.IsNullOrEmpty(example.OutputPrint) && interpreter.PrintStack.IsEmpty) {
+        return Data.WorstResult;
+      }
+
+      var printResult = interpreter.PrintStack.ToString();
+      var distance = example.OutputPrint.LevenshteinDistance(printResult);
+      var lineCountWithCorrectFormat = interpreter.PrintStack.AsStrings().Count(line => {
+        var parts = line.Split(' ');
+
+        if (parts.Length != 3)
+          return false;
+
+        var part0 = parts[0].Trim();
+        if (part0.Length == 0 || !part0.IsNumeric())
+          return false;
+
+        var part1 = parts[1].Trim();
+        if (part1.Length != 1)
+          return false;
+
+        var part2 = parts[2].Trim();
+        if (part2.Length != 1)
+          return false;
+
+        return true;
+      });
+
+      var lineCountWithInvalidFormat = example.OutputPrintLineCount - lineCountWithCorrectFormat;
+      lineCountWithInvalidFormat = Math.Min(lineCountWithInvalidFormat, example.OutputPrintLineCount);
+
+      var result = distance + lineCountWithInvalidFormat;
+      return Math.Min(result, Data.WorstResult);
+    }
+
+    private double EvenSquares(IPushInterpreter interpreter, Example example) {
+      if (string.IsNullOrEmpty(example.OutputPrint) && interpreter.PrintStack.IsEmpty) {
+        return 0.0;
+      }
+
+      if (!string.IsNullOrEmpty(example.OutputPrint) && interpreter.PrintStack.IsEmpty) {
+        return Data.WorstResult;
+      }
+
+      var distance = example.OutputPrint.LevenshteinDistance(interpreter.PrintStack.ToString());
+      var printLines = interpreter.PrintStack.AsStrings().ToArray();
+      var lineCountWithCorrectFormat = printLines.Count(line => line.IsNumeric());
+      var lineCountWithInvalidFormat = example.OutputPrintLineCount - lineCountWithCorrectFormat;
+
+      lineCountWithInvalidFormat = Math.Abs(Math.Min(lineCountWithInvalidFormat, example.OutputPrintLineCount));
+
+      var compareLength = Math.Min(printLines.Length, example.OutputPrintLineCount);
+      long integerError = 0;
+
+      for (var i = 0; i < compareLength; i++) {
+        long value;
+        if (long.TryParse(printLines[i], out value)) {
+          integerError += Math.Abs(value - example.OutputIntegerVector[0][i]);
+        } else {
+          integerError += example.OutputPrintLineCount > 0
+            ? (long)(Data.WorstResult / example.OutputPrintLineCount)
+            : 0;
+        }
+      }
+
+      var result = distance + lineCountWithInvalidFormat + integerError;
+      return Math.Min(result, Data.WorstResult);
+    }
+
+    private double WallisPi(IPushInterpreter interpreter, Example example) {
+      if (interpreter.FloatStack.IsEmpty)
+        return Data.WorstResult;
+
+      var floatDiff = GetDiff(example.OutputFloat, interpreter.FloatStack, Data.WorstResult, (a, b) => FloatDiffer(a, b, example.OutputFloatPrecision));
+      var expectedStr = example.OutputFloat[0].ToString(Data.FloatStringFormat, CultureInfo.CurrentCulture);
+      var resultStr = interpreter.FloatStack.TopOrDefault.ToString(Data.FloatStringFormat, CultureInfo.CurrentCulture);
+      var distance = expectedStr.LevenshteinDistance(resultStr);
+
+      var result = floatDiff + distance;
+      return Math.Min(result, Data.WorstResult);
+    }
+
+    private double VectorsSummed(IPushInterpreter interpreter, Example example) {
+      if (interpreter.IntegerVectorStack.IsEmpty && example.OutputIntegerVector.Length > 0)
+        return Data.WorstResult;
+
+      var resultVector = interpreter.IntegerVectorStack[0];
+      var expectedVector = example.OutputIntegerVector[0];
+      var comparableLength = Math.Min(resultVector.Count, expectedVector.Length);
+
+      // add penalty if length does not match
+      var result = expectedVector.Length > 0
+        ? (expectedVector.Length - comparableLength) * (Data.WorstResult / expectedVector.Length)
+        : 0;
+
+      for (var i = 0; i < comparableLength; i++) {
+        result += Math.Abs(resultVector[i] - expectedVector[i]);
+      }
+
+      return Math.Min(result, Data.WorstResult);
+    }
+
+    private double XWordLines(IPushInterpreter interpreter, Example example) {
+      if (string.IsNullOrEmpty(example.OutputPrint) && interpreter.PrintStack.IsEmpty) {
+        return 0.0;
+      }
+
+      if (!string.IsNullOrEmpty(example.OutputPrint) && interpreter.PrintStack.IsEmpty)
+        return Data.WorstResult;
+
+      var estimatedWordsPerLineCount = example.InputInteger[0];
+      var estimatedWordCount = example.OutputInteger[0];
+      var estimatedLastWordCount = estimatedWordCount - estimatedWordsPerLineCount * Math.Max(0, example.OutputPrintLineCount - 1);
+      var printResult = interpreter.PrintStack.ToString();
+      var distance = example.OutputPrint.LevenshteinDistance(printResult);
+      var lineCount = interpreter.PrintStack.Count;
+      var lineCountError = Math.Abs(example.OutputPrintLineCount - lineCount);
+      var totalWordsPerLineError = 0L;
+
+      for (var i = 0; i < interpreter.PrintStack.Lines.Count - 1; i++) {
+        totalWordsPerLineError += Math.Abs(interpreter.PrintStack.Lines[i].Split(' ').Length - estimatedWordsPerLineCount);
+      }
+
+      // last line
+      var lastLine = interpreter.PrintStack.Lines[interpreter.PrintStack.Lines.Count - 1];
+      totalWordsPerLineError += Math.Abs(lastLine.Split(' ').Length - estimatedLastWordCount);
+
+      var result = distance + lineCountError + totalWordsPerLineError;
+      return Math.Min(result, Data.WorstResult);
+    }
+
+    private double NegativeToZero(IPushInterpreter interpreter, Example example) {
+      if (interpreter.IntegerVectorStack.IsEmpty && example.OutputIntegerVector.Length > 0)
+        return Data.WorstResult;
+
+      var resultVector = interpreter.IntegerVectorStack.Top;
+      var expectedVector = example.OutputIntegerVector[0];
+      var comparableLength = Math.Min(resultVector.Count, expectedVector.Length);
+
+      // add penalty if length does not match
+      var result = expectedVector.Length > 0
+        ? (expectedVector.Length - comparableLength) * (Data.WorstResult / expectedVector.Length)
+        : 0;
+
+      for (var i = 0; i < comparableLength; i++) {
+        var expectedStr = expectedVector[i].ToString();
+        var resultStr = resultVector[i].ToString();
+        result += expectedStr.LevenshteinDistance(resultStr);
+      }
+
+      return Math.Min(result, Data.WorstResult);
+    }
+
+    private double WordStats(IPushInterpreter interpreter, Example example) {
+      if (string.IsNullOrEmpty(example.OutputPrint) && interpreter.PrintStack.IsEmpty) {
+        return 0.0;
+      }
+
+      if (!string.IsNullOrEmpty(example.OutputPrint) && interpreter.PrintStack.IsEmpty)
+        return Data.WorstResult;
+
+      var printStr = interpreter.PrintStack.ToString();
+      var distance = example.OutputPrint.LevenshteinDistance(printStr);
+
+      var statsError = 0.0;
+      long numberOfSentences;
+      var expectedNumberOfSentences = example.OutputInteger[0];
+      statsError += BenchmarkSuite.Problems.WordStats.GetNumberOfSentences(printStr, out numberOfSentences)
+        ? Math.Abs(expectedNumberOfSentences - numberOfSentences)
+        : Data.WorstResult / 3.0;
+
+      double averageSentenceLength;
+      var expectedAverageSentenceLength = example.OutputFloat[0];
+      statsError += BenchmarkSuite.Problems.WordStats.GetAverageSentenceLength(printStr, out averageSentenceLength)
+        ? Math.Abs(expectedAverageSentenceLength - averageSentenceLength)
+        : Data.WorstResult / 3.0;
+
+      var result = distance + statsError;
+      return Math.Min(result, Data.WorstResult);
+    }
+
+    private double Checksum(IPushInterpreter interpreter, Example example) {
+      if (!string.IsNullOrEmpty(example.OutputPrint) && interpreter.PrintStack.IsEmpty)
+        return Data.WorstResult;
+
+      var printStr = interpreter.PrintStack.ToString();
+      var distance = example.OutputPrint.LevenshteinDistance(printStr);
+
+      var expectedLastCharIndex = example.OutputPrint.Length - 1;
+      var result = distance;
+
+      if (expectedLastCharIndex >= 0) {
+        var expectedLastChar = example.OutputPrint[expectedLastCharIndex];
+        var resultLastCharIndex = printStr.Length - 1;
+
+        if (resultLastCharIndex >= 0) {
+          var resultLastChar = printStr[resultLastCharIndex];
+          result += Math.Abs(expectedLastChar - resultLastChar);
+        }
+      }
+
+      return Math.Min(result, Data.WorstResult);
+    }
+
+    private double Syllables(IPushInterpreter interpreter, Example example) {
+      if (!string.IsNullOrEmpty(example.OutputPrint) && interpreter.PrintStack.IsEmpty)
+        return Data.WorstResult;
+
+      var printStr = interpreter.PrintStack.ToString();
+      var distance = example.OutputPrint.LevenshteinDistance(printStr);
+
+      long numberOfSyllables;
+      var expectedNumberOfSyllables = example.OutputInteger[0];
+      var numberOfSyllablesError = BenchmarkSuite.Problems.Syllables.GetNumberOfSyllables(printStr, out numberOfSyllables)
+        ? Math.Abs(expectedNumberOfSyllables - numberOfSyllables)
+        : Data.WorstResult / 2.0;
+
+      var result = distance + numberOfSyllablesError;
+      return Math.Min(result, Data.WorstResult);
+    }
+
+    private double Grade(IPushInterpreter interpreter, Example example) {
+      if (!string.IsNullOrEmpty(example.OutputPrint) && interpreter.PrintStack.IsEmpty)
+        return Data.WorstResult;
+
+      var printStr = interpreter.PrintStack.ToString();
+      var distance = example.OutputPrint.LevenshteinDistance(printStr);
+
+      char grade;
+      var expectedGrade = example.OutputChar[0];
+      var gradeError = BenchmarkSuite.Problems.Grades.GetGrade(printStr, out grade)
+        ? Math.Abs(expectedGrade - grade)
+        : Data.WorstResult / 2;
+
+      var result = distance + gradeError;
+      return Math.Min(result, Data.WorstResult);
     }
 
@@ -215,5 +505,5 @@
 
     private static double StringDiffer(string a, string b) {
-      return LevenshteinDistance(a, b);
+      return a.LevenshteinDistance(b);
     }
 
@@ -240,5 +530,5 @@
 
     private static double GetPrintDiffer(string estimated, string printResult, double worstResult) {
-      var distance = LevenshteinDistance(estimated, printResult);
+      var distance = estimated.LevenshteinDistance(printResult);
 
       return Math.Min(distance, worstResult);
@@ -247,5 +537,5 @@
     private static double GetPrintDiffer(string estimated, IPrintStack printStack, double worstResult) {
       var printResult = printStack.ToString();
-      var distance = LevenshteinDistance(estimated, printResult);
+      var distance = estimated.LevenshteinDistance(printResult);
 
       return Math.Min(distance, worstResult);
@@ -293,49 +583,4 @@
       return diff;
     }
-
-    /// <summary>
-    /// https://www.dotnetperls.com/levenshtein
-    /// </summary>
-    private static int LevenshteinDistance(string source, string target) {
-      if (source == null && target == null) return 0;
-      if (source == null) return target.Length;
-      if (target == null) return source.Length;
-
-      int n = source.Length;
-      int m = target.Length;
-      int[,] d = new int[n + 1, m + 1];
-
-      // Step 1
-      if (n == 0) {
-        return m;
-      }
-
-      if (m == 0) {
-        return n;
-      }
-
-      // Step 2
-      for (int i = 0; i <= n; d[i, 0] = i++) {
-      }
-
-      for (int j = 0; j <= m; d[0, j] = j++) {
-      }
-
-      // Step 3
-      for (int i = 1; i <= n; i++) {
-        //Step 4
-        for (int j = 1; j <= m; j++) {
-          // Step 5
-          int cost = (target[j - 1] == source[i - 1]) ? 0 : 1;
-
-          // Step 6
-          d[i, j] = Math.Min(
-              Math.Min(d[i - 1, j] + 1, d[i, j - 1] + 1),
-              d[i - 1, j - 1] + cost);
-        }
-      }
-      // Step 7
-      return d[n, m];
-    }
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs	(revision 15334)
@@ -94,5 +94,6 @@
     "CODE.QUOTE",
     "Specifies that the next expression submitted for execution will instead be pushed literally onto the CODE stack.",
-    StackTypes.Exec)]
+    StackTypes.Exec,
+    requiredBlockCount: 1)]
   [StorableClass]
   public class CodeQuoteExpression : StatelessExpression {
@@ -175,13 +176,13 @@
 
           if (secondProgram.Depth > interpreter.Configuration.MaxDepth ||
-              firstProgram.Count + secondProgram.Count > interpreter.Configuration.MaxPointsInProgram)
+              firstProgram.Count + secondProgram.Count > interpreter.Configuration.MaxProgramLength)
             return;
-        } else if (firstProgram.Count + 1 > interpreter.Configuration.MaxPointsInProgram) return;
+        } else if (firstProgram.Count + 1 > interpreter.Configuration.MaxProgramLength) return;
       } else if (second.IsProgram) {
         secondProgram = (PushProgram)second;
 
         if (secondProgram.Depth > interpreter.Configuration.MaxDepth
-            || secondProgram.Count + 1 > interpreter.Configuration.MaxPointsInProgram) return;
-      } else if (interpreter.Configuration.MaxPointsInProgram <= 2) {
+            || secondProgram.Count + 1 > interpreter.Configuration.MaxProgramLength) return;
+      } else if (interpreter.Configuration.MaxProgramLength <= 2) {
         return;
       }
@@ -318,5 +319,5 @@
       return interpreter.CodeStack.Count < 2 ||
             (interpreter.CodeStack.Top.IsProgram &&
-            ((PushProgram)interpreter.CodeStack.Top).Expressions.Count + 1 > interpreter.Configuration.MaxPointsInProgram);
+            ((PushProgram)interpreter.CodeStack.Top).Expressions.Count + 1 > interpreter.Configuration.MaxProgramLength);
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs	(revision 15334)
@@ -68,5 +68,5 @@
     "Defines the name on top of the NAME stack as an instruction that will push the top item of the EXEC stack onto the EXEC stack.",
     StackTypes.Name,
-    execIn: 1)]
+    requiredBlockCount: 1)]
   [StorableClass]
   public class ExecDefineExpression : DefineExpression<Expression> {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs	(revision 15334)
@@ -57,5 +57,5 @@
     "An iteration instruction that performs a loop (the body of which is taken from the EXEC stack) the number of times indicated by the INTEGER argument, pushing an index (which runs from zero to one less than the number of iterations) onto the INTEGER stack prior to each execution of the loop body.",
     StackTypes.Integer,
-    execIn: 1)]
+    requiredBlockCount: 1)]
   public class ExecDoCountExpression : StatelessExpression {
     public ExecDoCountExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs	(revision 15334)
@@ -83,5 +83,5 @@
     description: "An iteration instruction that executes the top item on the EXEC stack a number of times that depends on the top two integers, while also pushing the loop counter onto the INTEGER stack for possible access during the execution of the body of the loop.",
     additionalStackDependencies: StackTypes.Integer,
-    execIn: 1)]
+    requiredBlockCount: 1)]
   public class ExecDoRangeExpression : StatelessExpression {
     public ExecDoRangeExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs	(revision 15334)
@@ -68,5 +68,5 @@
   [Serializable]
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.DO*TIMES", "Like EXEC.DO*COUNT but does not push the loop counter", StackTypes.Integer, execIn: 1)]
+  [PushExpression(StackTypes.Exec, "EXEC.DO*TIMES", "Like EXEC.DO*COUNT but does not push the loop counter", StackTypes.Integer, requiredBlockCount: 1)]
   public class ExecDoTimesExpression : StatelessExpression {
     public ExecDoTimesExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs	(revision 15334)
@@ -88,5 +88,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.DUP", "Duplicates the top item on the EXEC stack." , execIn: 1)]
+  [PushExpression(StackTypes.Exec, "EXEC.DUP", "Duplicates the top item on the EXEC stack." , requiredBlockCount: 1)]
   public class ExecDuplicateExpression : DuplicateExpression<Expression> {
     public ExecDuplicateExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EmptyExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EmptyExpression.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EmptyExpression.cs	(revision 15334)
@@ -72,4 +72,5 @@
   }
 
+  [StorableClass]
   [PushExpression(
     StackTypes.Float,
@@ -85,9 +86,9 @@
   }
 
+  [StorableClass]
   [PushExpression(
     StackTypes.Boolean,
     "BOOLEAN.EMPTY",
-    "Pushes TRUE onto the BOOLEAN stack if the BOOLEAN stack is empty, otherwise FALSE.",
-    StackTypes.Boolean)]
+    "Pushes TRUE onto the BOOLEAN stack if the BOOLEAN stack is empty, otherwise FALSE.")]
   public class BooleanEmptyExpression : EmptyExpression<bool> {
     public BooleanEmptyExpression() { }
@@ -99,4 +100,5 @@
   }
 
+  [StorableClass]
   [PushExpression(
     StackTypes.Char,
@@ -113,4 +115,5 @@
   }
 
+  [StorableClass]
   [PushExpression(
     StackTypes.String,
@@ -127,4 +130,5 @@
   }
 
+  [StorableClass]
   [PushExpression(
     StackTypes.IntegerVector,
@@ -141,4 +145,5 @@
   }
 
+  [StorableClass]
   [PushExpression(
     StackTypes.FloatVector,
@@ -155,4 +160,5 @@
   }
 
+  [StorableClass]
   [PushExpression(
     StackTypes.BooleanVector,
@@ -169,4 +175,5 @@
   }
 
+  [StorableClass]
   [PushExpression(
     StackTypes.StringVector,
